"use strict";

// Generated by CoffeeScript 2.2.2
// iplotCorr: heatmap of correlation matrix linked to scatterplots
// Karl W Broman
HTMLWidgets.widget({
  name: "iplotCorr",
  type: "output",
  initialize: function initialize(widgetdiv, width, height) {
    if (height > width / 2) {
      // prefer aspect ratio width/height = 2
      height = width / 2;
    }
    return d3.select(widgetdiv).append("svg").attr("width", width).attr("height", height).attr("class", "qtlcharts");
  },
  renderValue: function renderValue(widgetdiv, x) {
    var chartOpts, ref, ref1, ref2, svg, widgetid;
    svg = d3.select(widgetdiv).select("svg");
    // clear svg and remove tool tips
    svg.selectAll("*").remove();
    widgetid = d3.select(widgetdiv).attr('id');
    d3.selectAll("div.d3-tip." + widgetid).remove();
    chartOpts = (ref = x.chartOpts) != null ? ref : [];
    chartOpts.width = (ref1 = chartOpts != null ? chartOpts.width : void 0) != null ? ref1 : svg.attr("width");
    chartOpts.height = (ref2 = chartOpts != null ? chartOpts.height : void 0) != null ? ref2 : svg.attr("height");
    // revise size of svg and div container
    svg.attr("width", chartOpts.width);
    svg.attr("height", chartOpts.height);
    d3.select(widgetdiv).attr("style", "width:" + chartOpts.width + "px;height:" + chartOpts.height + "px;");
    if (x.data.scatterplots) {
      return iplotCorr(widgetdiv, x.data, chartOpts);
    } else {
      return iplotCorr_noscat(widgetdiv, x.data, chartOpts);
    }
  },
  resize: function resize(widgetdiv, width, height) {
    return d3.select(widgetdiv).select("svg").attr("width", width).attr("height", height);
  }
});